/** @file emif.c
*   @brief emif Driver Implementation File
*   @date 12.Feb.2014
*   @version 03.08.00
*
*/

/* (c) Texas Instruments 2009-2014, All rights reserved. */

/* USER CODE BEGIN (0) */
/* USER CODE END */

#include "emif.h"

/* USER CODE BEGIN (1) */
/* USER CODE END */

/** @fn void emif_ASYNC1Init(void)
*   @brief Initializes the emif Driver for ASYNC memories
*
*   This function initializes the emif driver for Asynchronous memories like Nor and Nand Flashes,Asynchronous RAM.
*/
/* SourceId : EMIF_SourceId_002 */
/* DesignId : EMIF_DesignId_002 */
/* Requirements: HL_SR335 */
void emif_ASYNC1Init(void)
{
/* USER CODE BEGIN (4) */
/* USER CODE END */
    emifREG->CE2CFG = 0x00000000U;
    emifREG->CE2CFG = (uint32)((uint32)0U << 31U)|
                      (uint32)((uint32)0U << 30U)|
                      (uint32)((uint32)0U << 26U)|
                      (uint32)((uint32)2U << 20U)|
                      (uint32)((uint32)3U << 17U)|
                      (uint32)((uint32)0U << 13U)|
                      (uint32)((uint32)3U << 7U)|
                      (uint32)((uint32)0U << 4U)|
                      (uint32)((uint32)0U << 2U)|
                      (uint32)((uint32)emif_16_bit_port);
	                  
    emifREG->AWCC   = (emifREG->AWCC)|
	     			  (uint32)((uint32)emif_pin_high << 29U)|
		    		  (uint32)((uint32)emif_pin_low << 28U)|
			    	  (uint32)((uint32)emif_wait_pin0 << 16U)|
			    	  (uint32)((uint32)0U);
					
    emifREG->PMCR   = (emifREG->PMCR)|
	    			  (uint32)((uint32)1U << 2U)|
		    		  (uint32)((uint32)emif_4_words << 1U)|
			    	  (uint32)((uint32)0U);
/* USER CODE BEGIN (5) */
   // systemREG1->GPREG1 |= 0x80000000;

/* USER CODE END */
}

/** @fn void emif_ASYNC2Init(void)
*   @brief Initializes the emif Driver for ASYNC memories
*
*   This function initializes the emif driver for Asynchronous memories like Nor and Nand Flashes,Asynchronous RAM.
*/
/* SourceId : EMIF_SourceId_003 */
/* DesignId : EMIF_DesignId_002 */
/* Requirements: HL_SR335 */
void emif_ASYNC2Init(void)
{
/* USER CODE BEGIN (6) */
/* USER CODE END */

    emifREG->CE3CFG = 0x00000000U;
    emifREG->CE3CFG = (uint32)((uint32)0U << 31U)|
                      (uint32)((uint32)0U << 30U)|
                      (uint32)((uint32)1U << 26U)|
                      (uint32)((uint32)3U << 20U)|
                      (uint32)((uint32)1U << 17U)|
                      (uint32)((uint32)1U << 13U)|
                      (uint32)((uint32)3U << 7U)|
                      (uint32)((uint32)1U << 4U)|
                      (uint32)((uint32)0U << 2U)|
                      (uint32)((uint32)emif_16_bit_port);
	                  
    emifREG->AWCC   = (emifREG->AWCC)|
	     			  (uint32)((uint32)emif_pin_high << 29U)|
		    		  (uint32)((uint32)emif_pin_low << 28U)|
			    	  (uint32)((uint32)emif_wait_pin0 << 18U)|
			    	  (uint32)((uint32)0U);
					
    emifREG->PMCR   = (emifREG->PMCR)|
	    			  (uint32)((uint32)0U << 10U)|
		    		  (uint32)((uint32)emif_4_words << 9U)|
			    	  (uint32)((uint32)0U << 8U);
/* USER CODE BEGIN (7) */
/* USER CODE END */
	                  
}



/* USER CODE BEGIN (10) */
/* USER CODE END */

/** @fn void emifGetConfigValue(emif_config_reg_t *config_reg, config_value_type_t type)
*   @brief Get the initial or current values of the EMIF configuration registers
*
*	@param[in] *config_reg: pointer to the struct to which the initial or current 
*                           value of the configuration registers need to be stored
*	@param[in] type: 	whether initial or current value of the configuration registers need to be stored
*						- InitialValue: initial value of the configuration registers will be stored 
*                                       in the struct pointed by config_reg
*						- CurrentValue: initial value of the configuration registers will be stored 
*                                       in the struct pointed by config_reg
*
*   This function will copy the initial or current value (depending on the parameter 'type') 
*   of the configuration registers to the struct pointed by config_reg
*
*/
/* SourceId : EMIF_SourceId_005 */
/* DesignId : EMIF_DesignId_003 */
/* Requirements: HL_SR336 */
void emifGetConfigValue(emif_config_reg_t *config_reg, config_value_type_t type)
{
	if (type == InitialValue)
	{
		config_reg->CONFIG_AWCC    = EMIF_AWCC_CONFIGVALUE;  
		config_reg->CONFIG_SDCR    = EMIF_SDCR_CONFIGVALUE;  
		config_reg->CONFIG_SDRCR   = EMIF_SDRCR_CONFIGVALUE;
		config_reg->CONFIG_CE2CFG  = EMIF_CE2CFG_CONFIGVALUE;
		config_reg->CONFIG_CE3CFG  = EMIF_CE3CFG_CONFIGVALUE;
		config_reg->CONFIG_CE4CFG  = EMIF_CE4CFG_CONFIGVALUE;
		config_reg->CONFIG_CE5CFG  = EMIF_CE5CFG_CONFIGVALUE;
		config_reg->CONFIG_SDTIMR  = EMIF_SDTIMR_CONFIGVALUE;
		config_reg->CONFIG_SDSRETR = EMIF_SDSRETR_CONFIGVALUE;
		config_reg->CONFIG_INTRAW  = EMIF_INTRAW_CONFIGVALUE;
		config_reg->CONFIG_INTMSK  = EMIF_INTMSK_CONFIGVALUE;
		config_reg->CONFIG_PMCR    = EMIF_PMCR_CONFIGVALUE;
	}
	else
	{
	/*SAFETYMCUSW 134 S MR:12.2 <APPROVED> "LDRA Tool issue" */
		config_reg->CONFIG_AWCC     = emifREG->AWCC;  
		config_reg->CONFIG_SDCR     = emifREG->SDCR;  
		config_reg->CONFIG_SDRCR    = emifREG->SDRCR ;
		config_reg->CONFIG_CE2CFG   = emifREG->CE2CFG;
		config_reg->CONFIG_CE3CFG   = emifREG->CE3CFG;
		config_reg->CONFIG_CE4CFG   = emifREG->CE4CFG;
		config_reg->CONFIG_CE5CFG   = emifREG->CE5CFG;
		config_reg->CONFIG_SDTIMR   = emifREG->SDTIMR;
		config_reg->CONFIG_SDSRETR  = emifREG->SDSRETR;
		config_reg->CONFIG_INTRAW   = emifREG->INTRAW;
		config_reg->CONFIG_INTMSK   = emifREG->INTMSK;
		config_reg->CONFIG_PMCR     = emifREG->PMCR;
	}
}


