/** @file sys_main.c 
*   @brief Application main file
*   @date 12.Feb.2014
*   @version 03.08.00
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* (c) Texas Instruments 2009-2014, All rights reserved. */

/* USER CODE BEGIN (0) */
#include "het.h"
#include "emif.h"
/* USER CODE END */

/* Include Files */

#include "sys_common.h"

/* USER CODE BEGIN (1) */
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */

#define BASE_PERIPH		0x60000000
#define BASE_SRAM		0x64000000
#define BASE_CS4		0x68000000
#define BASE_SDRAM		0x80000000

uint16_t* pBase;
uint16_t* pBaseIF;

int16_t adc_res[16];

/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
	uint16_t i,j, pattern, fwver, pcbver;

	pBase = (uint16_t*)BASE_SRAM;
	pBaseIF = (uint16_t*)BASE_PERIPH;

	systemInit();

	hetInit();

	systemREG1->GPREG1 |= 0x80000000; // this must be there for proper function of EMIF, see SPNU499B p. 158

	//emif_SDRAMInit();
	emif_ASYNC1Init(); // setup peripherals EMIF
	emif_ASYNC2Init(); // setup ext. RAM EMIF
	emif_ASYNC3Init(); // not used

	i=0;

	// read version of firmware
	fwver = *pBaseIF;
	// read pcb ver
	pcbver = *(pBaseIF+0x000F);

	*(pBaseIF+0x012) = 'A';


	for (i=0;i<16;i++){
		adc_res[i] = *(pBaseIF+0x0001);
	}


	pattern = 0x5555;
	while(1){
		for(i=0;i<0xFFFF;i++){
			*((uint16_t*)BASE_SRAM+i) = i;
			if (*((uint16_t*)BASE_SRAM+i) != i)
				while(1);
		}
	}




	while(1);
/* USER CODE END */
}

/* USER CODE BEGIN (4) */
/* USER CODE END */
